{*************************************************************************
                Copyright (c) PilotLogic Software House

  Package pl_ORCA
  This file is part of CodeTyphon Studio (https://www.pilotlogic.com/)

 ***** BEGIN LICENSE BLOCK *****
 * Version: LGPL-2.1 with link exception (Modified LGPL)
 *
 * The contents of this file are subject to the 
 * GNU LIBRARY GENERAL PUBLIC LICENSE Version 2.1 (the "License")
 * with the following modification:
 * 
 * As a special exception, the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your choice,
 * provided that you also meet, for each linked independent module, the terms
 * and conditions of the license of that module. An independent module is a
 * module which is not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library, but
 * you are not obligated to do so. If you do not wish to do so, delete this
 * exception statement from your version.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * ***** END LICENSE BLOCK *****
 
***************************************************************************}

Unit pangocairo_gtk2_api;

{$mode objfpc}{$H+}

{$I orca_define.inc}
{$H+}
{$ALIGN ON}
{$MINENUMSIZE 4}

Interface

Uses
   SysUtils, dynlibs,
   {$IFDEF ORCA2D_USE_GTK2}
    {$IFDEF ORCA2D_OS_DARWIN}
     agl, gl, glext, MacOsAll, CarbonPrivate, CarbonDef,
    {$ELSE}
     glx, cairo, cairoXlib, xlib, x, xutil,
     glib2,
     gtk2def, gtk2proc, gtk2, gdk2, gdk2x, gdk2pixbuf,
     pango,pangocairo,
    {$ENDIF}
   {$ENDIF}
   LCLProc, LCLIntf, LCLType;

//Missing from fpcsrc/packges/gtk2/src/../  gdk2.pas
Function gdk_screen_get_rgba_colormap(Const screen: PGdkScreen): PGdkColormap; Cdecl; External gdklib;

//Missing from fpcsrc/packages/gtk2/src/../ gdk2pixbuf.pas
Function gdk_pixbuf_get_file_info(filename: PChar; Var Width, Height: gint): Integer; Cdecl; External gdkpixbuflib;

Function gdk_pixbuf_save_to_bufferv(pb: PGdkPixbuf; Var bug: Pbyte; Var Len: gsize; Const typ: PChar; option_keys: PPchar; option_values: PPchar; Error: Pointer): gboolean; Cdecl; External gdkpixbuflib;

// Missing from fpcsrc/packages/gtk2/src/pango/ pango-layout.inc
Procedure pango_layout_set_height(layout: PPangoLayout; Height: Longint); Cdecl; External pangolib;


Implementation

End.
